<!DOCTYPE html>
<html>
<head>
  <meta charset="UTF-8">
  <title>Forms Task 1</title>
  <script>
    /*
      Задание:
        Сделать валидацию формы:
        1. Логин / Пароль не может быть пустым
        2. Пароли должны совпадть
        3. Пока не стоит что юзер согласен с лиц. соглашением - кнопка отправки не активна

        + бонус - то поле, которое не прошло валидацию подсвечивать красным.
                - которое прошло - подсвечивать зеленым.
    */
  </script>
</head>
<body>
  <form id="MyValidateForm" name="MyValidateForm">
    <input type="text" name='login' placeholder="Ваш логин" />
    <input type="password" name='pas1' placeholder="Ваш пароль" />
    <input type="password" name='pas2' placeholder="Повторите пароль" />
    <label for="agree">
      <span>Вы согласны с лицензионым соглашением.</span>
      <input type="checkbox" id="agree" />
    </label>
    <input type="submit" id="submit" value="Отправить" disabled/>
  </form>

  <script>
    document.addEventListener('DOMContentLoaded', function(){
      const MyValidateForm = document.forms.MyValidateForm;  
      const login = MyValidateForm.elements.login;
      const pass = MyValidateForm.elements.pas1;
      const passRepeat = MyValidateForm.elements.pas2;
      const agree = MyValidateForm.elements.agree;
      const submit = MyValidateForm.elements.submit;

      function showInvalid (elem) {
        elem.classList.remove('error', 'OK');
        elem.classList.add('error');
      }

      function showValid (elem) {
        elem.classList.remove('OK', 'error');
        elem.classList.add('OK');
      }

      function getValidate (format = 'OK', elem) {
        var option = {
          'error': showInvalid,
          'OK': showValid
        }
        return option[format](elem);
      }

      function validateForm () {
        if (login.value) {
          getValidate('OK', login)
        } else {
          getValidate('error', login)
        }
        if (pass.value && passRepeat.value && pass.value === passRepeat.value) {
          getValidate('OK', pass)
          getValidate('OK', passRepeat)
        } else {
          getValidate('error', pass)
          getValidate('error', passRepeat)
        }
      }

      function submitForm(e) {
        e.preventDefault();
        console.log(agree.checked);
        if(agree.checked) {
          validateForm();
        }
      }

      agree.addEventListener('click', function(){
        if (agree.checked) {
          submit.disabled = false;
          MyValidateForm.addEventListener('submit', submitForm); 
          console.log('add EventListener');
        } else {
          submit.disabled = true;
          MyValidateForm.removeEventListener('submit', submitForm);
          console.log('remove EventListener');
        }
      });
    });
  </script>

  <style>
    #MyValidateForm{
      width: 350px;
      display: flex;
      flex-direction: column;
    }

    #MyValidateForm input{
      margin-bottom: 10px;
      box-sizing: border-box;
      padding: 10px 20px;
    }
    
    .error{
        border: 2px solid red;
    }
    .OK{
        border: 2px solid green;
    }
  </style>
</body>
</html>
